; drv35.inc: AD9835 specifikus szubrutinok gyjtemnye.
; hasznlja a prlx.inc makrit.

; seldd a DDS IC kivlaszt jele (egy port latch bit)
; fselb a frekvenciaregisztert vlaszt bjt
; sel0-sel3 a ngy frekvenciasz kezd bjtjai
; ezeket a szubrutinok a nulls RAM lapon felttelezik.
; fblk a ngy kivitelre sznt bjt, legnagyobb ell.
; indirekt cmzs, mindegy, hogy melyik RAM lapon van.


; els frekvencia kivitele s aktivlsa
first
        call    ddsini		
        movl    fsr0l,fblk	;s fsr0l=fblk-val hvott egy ddsoutot
        call    ddsout
        pagesel	ddsact
        call    ddsact		; majd a megszakts elvgzi minden krben
	bsf	intcon,gie
        pagesel $
        return			


; j frekvenciasz kivitele az ppen passzivlt frekvenciaregiszterbe. 10
; bjt megy ki, s a leggyorsabb spi rajel kell neki.
; Magtl vltja a regisztert, beri azzal, hogy a 4 bjtos fblk blokkban
; megkapja az adatot (MSB first).
; kvetheti az elz sz aktivlst a megszaktsban.
ddsout
	movlw	high fblk
	movwf	fsr0h
	movlw	low fblk
	movwf	fsr0l
	banksel	lata
        bcf     seldd
        banksel	sel0
	movf    sel0,w
        banksel	sspbuf
        movwf   sspbuf
        banksel	porta
        sb      fselb,3
        bcf     sel0,2
        snb     fselb,3
        bsf     sel0,2
        moviw   fsr0++
	call	dly4
	call	dly4
	banksel	sspbuf
        movwf   sspbuf
        banksel	porta
        call	dly4
        call	dly4
        nop
        banksel	lata
        bsf     seldd
        banksel	porta
        movf    sel1,w
        banksel	lata
        bcf     seldd
        banksel	sspbuf
        movwf   sspbuf
        banksel	porta
        sb      fselb,3
        bcf     sel1,2
        snb     fselb,3
        bsf     sel1,2
        moviw   fsr0++
        call	dly4
        call	dly4
        banksel	sspbuf
        movwf   sspbuf
        banksel	porta
        call	dly4
        call	dly4
        nop
        banksel	lata
        bsf     seldd
        banksel	porta
        movf    sel2,w
        banksel	lata
        bcf     seldd
        banksel	sspbuf
        movwf   sspbuf
        banksel	porta
        sb      fselb,3
        bcf     sel2,2
        snb     fselb,3
        bsf     sel2,2
        moviw	fsr0++
        call	dly4
        call	dly4
        banksel	sspbuf
        movwf   sspbuf
        banksel	porta
        call	dly4
        call	dly4
        nop
        banksel	lata
        bsf     seldd
        banksel	porta
        movf    sel3,w
        banksel	lata
        bcf     seldd
        banksel	sspbuf
        movwf   sspbuf
        banksel	porta
        sb      fselb,3
        bcf     sel3,2
        snb     fselb,3
        bsf     sel3,2
        moviw	fsr0++
        call	dly4
        call	dly4
        banksel	sspbuf
        movwf   sspbuf
        banksel	porta
        movlw	8
        xorwf   fselb,f
        call	dly4
        call	dly4
        banksel	lata
        bsf     seldd
	banksel	porta
dly4
        return

; Az elzleg feltlttt frekvenciaregiszter aktivlsa (az idztett
; megszakts elejn kell hvni):
ddsact  
	banksel	lata
	bcf     seldd
	banksel	fselb
	movf	fselb,w
	banksel	sspbuf
        movwf   sspbuf
        call	szun4
        call	szun4
        movl    fsr0l,fblk	
        call	szun4
        nop
        nop
        clrw
        movwf   sspbuf
        call	szun4
        call	szun4
        call	szun4
        call	szun4
        banksel	lata
        bsf     seldd
        banksel	porta
szun4
        return

; bjt kivitele a kivlasztott SPI perifrira. A ddsout nem hasznlja. 
; alkalmas w-bl a kijellt perifrira. A perifrit a rutinon kvl 
; Ezt a rutint lehet hasznlni pl. a DDS ic incializlsra s 
; lelltsra kt bjt/kivlaszts), vagy  ramp genertorhoz (ami egy 
; DAC, mr ha van ilyen).
bout
	banksel	sspbuf
	movwf   sspbuf
        nop
        nop
        nop
        nop
        nop
        nop
	nop
        banksel	lata
        return

; hvssal egytt 8 utaststem ksleltets:
dum
	nop
	nop
	nop
	nop
	return

; a dds komplett inicializlsa indts nlkl
fullini
        call    spiini          ; spi incializls
        call    fstopd          ; dds lell
;        call    stopd
        call    confd           ; dds konfigurls
        call    p00             ; dds 0 fzisra
        call    ddsini          ; dds incializls
        goto    stopd           ; dds sleep (mkdhetne, de alszik)

; az spi perifria incializlsa: max. sebessg, idle=0, olvass mindegy, 
; mert nem olvassuk
spiini
	banksel	sspcon1
	clrf    sspcon1
        bsf     sspstat,7
        bcf     sspstat,6
        bsf	sspcon3,boen
        bsf     sspcon1,sspen
        banksel	porta
        return

; a ddsout-hoz szksges regiszterek incializlsa: 
ddsini
	movl    sel0,33h       ; nulls csoport
        movl    sel1,22h
        movl    sel2,31h
        movl    sel3,20h
        movl    fselb,58h      ; select f1
        return

stopd
	bcf     intcon,gie
	banksel	lata
        bcf     seldd
        banksel	porta
        movlw	0e0h         ; csak sleep
        call    bout
        clrw
        call    bout
        bsf     seldd
        banksel	porta
        bsf     intcon,gie
        return

fstopd				;mg nincs megszakts
	banksel lata
	bcf	seldd           ; sleep + reset + clear
        movlw	0f8h		; a clear magtl elmlik
        call    bout
        movlw	0
        call    bout
        bsf     seldd
        banksel	porta
        return

confd			    ; configure DDS
	banksel	lata
	bcf     seldd
        movlw	0h          ; 'program selected' registers
        call    bout
        movlw	0
        call    bout
        bsf     seldd
        nop
        bcf     seldd
        movlw	68h          ; select freq reg 1, phase reg 0
        call    bout
        movlw	0
        call    bout
        bsf     seldd
        banksel	porta
        return

p0180			     ; fzisfordts, ha kell	
	banksel	lata
	bcf     seldd          
        movlw	19h          ; write to ph0 upper
        call    bout
        movlw	080h         ; value 180 degrees (MSB)
        call    bout
        bsf     seldd
        nop
        bcf     seldd
        movlw	8h           ; lower
        call    bout
        movlw	0            ; value 180 degrees (LSB)
        call    bout
        bsf     seldd
        banksel	porta
        return

p00
	banksel	lata
	bcf     seldd
        movlw	19h          ; init ph0 to 0 degrees 
        call    bout
        movlw	0
        call    bout
        bsf     seldd
        nop
        bcf     seldd
        movlw	8h          ; 
        call    bout
        movlw	0
        call    bout
        bsf     seldd
        banksel	porta
        return

startd
	bcf	intcon,gie
	banksel	lata
	bcf     seldd
        movlw	0c0h         ; sleep s reset eltvoltva, mehet
        call    bout
        movlw	0
        call    bout
        bsf     seldd
        banksel	porta
        bsf	intcon,gie
        return
	     
