; CTCSS.asm: CTCSS genertor 50 frekvencira, 7 szegmenses kijelzvel. 32 MHz. 
; A flash rsi cm 1f81.

	list p = 16F1708
	list r = dec
	#include <p16f1708.inc>
	#include <prlx.inc>
	
	__config _CONFIG1, _FOSC_HS& _WDTE_OFF &_PWRTE_ON &_MCLRE_OFF & _CP_OFF &_BOREN_ON & _CLKOUTEN_OFF &_IESO_OFF &_FCMEN_OFF
	__CONFIG _CONFIG2, _WRT_OFF & _PLLEN_ON	& _STVREN_OFF & _BORV_LO & _LPBOR_OFF & _LVP_OFF
	
led	equ	3	; ez a tizedespont bitcme	
mask0	equ	40h	; fels digit
mask1	equ	20h	; kzps digit
mask2	equ	10h	; als digit (vagy fordtva)
mask3	equ	80h	; legals digit
i_uplim	equ	49	; index maximum
t_div3	equ	20	; gomb oszt, lervidtve

	cblock	20h
	f1		; csak a nulls lapra j jelzbitek, nincsenek
	mx_cnt		; multiplexer lasst szmll, mkdik
	g_cnt		; gomb szmll
	g_old		; gomb elz
	ind_s		; index ment
	p_dec:4		; csatorna decimlisan
	f_dec:4		; frekvencia decimlisan
	dac_buf
	endc
	
	cblock	70h
	tol:4		; a 10 bites cmzshez
	ph_acc:3	; fzisakkumultor, magas ell
	fr_reg:3	; frekvenciaregiszter, magas ell
	index		; a freki sorszma, 0...49
	flags		; jelzbitek, ksbb rszletezve
	aux		; ltalnos segdregiszter
	cim		; olvasshoz transzformlt index
	gombok		; neglt gombkp
	cnt		; brhonnan lthat szmll 
	endc
	
	#define	ptt	porta,1
	#define	dminus	porta,2
	#define keyin	porta,3	; gomb mux bemenet
	#define van	flags,0	; van gombnyoms
	#define	nincs	flags,1	; volt sznet
	#define do_sav	flags,3	; menteni kell
	#define fmod	flags,4	; freki kijelzs md
	#define	fut	flags,5	; ehhez mrem az stst kivnt hatst
	#define uj	flags,6	; j adat van,tlteni, indexet menteni
	#define sin_on	flags,7	; kell j pontot kirakni 
	#define le	g_old,0	; dekrementlni kell
	#define fel	g_old,1	; start/stop
	#define	stst	g_old,2	; inkrementlni kell
	#define	stepm	g_old,3 ; md lptetse
	#define	viszsz	f1,0	; visszaszmol
	#define	vissza	f1,1	; visszallt


	
	cblock	0x120	; mert lata, latb, latc oldala
	sbuf:4		; a 3 7 szegmenses szmjegy
	m4reg		; mux regiszter
	endc
	
	org	0
	clrf	pclath
	clrf	intcon
	goto	start
	
	org	4
	banksel	0
	jb	intcon,iocif,rev_ph
	bcf	pir1,tmr2if	; a megszakts flag trlse
	jnb	sin_on,d_mux	; flags,7 mindenhonnan
	movf	dac_buf,w
	banksel	dac1con0
	movwf	dac1con1
	banksel	0
	movf	fr_reg+2,w
	addwf	ph_acc+2,f
	movf	fr_reg+1,w	; mindenhonnan
	addwfc	ph_acc+1,f	; als bjt sszeadva
	movf	fr_reg,w
	addwfc	ph_acc,f	; fels bjt sszeadva
	#include <10bit.inc>	; ha ezt hasznlom, akkor a kvetkez
				; kt programsor el pontosvessz kell
;	movlp	high sinus	; ha ezt a kt sort hasznlom, akkor 
;	movf	ph_acc,w	; a #include <10bit.inc> el kell a ;
	callw
	movwf	dac_buf
	banksel	pwm3dch
	movwf	pwm3dch		; pwm kitltsbe rva
	clrf	pwm3dcl
	pagesel	0
	banksel	mx_cnt
	decfsz	mx_cnt,f	; multiplex lasst
	goto	raer
	movlw	32		; 1 kHz-re
	movwf	mx_cnt
d_mux
	banksel	latc		; kijelz multiplexels sbuf:4-bl	
	movf	m4reg,w		; soron kvetkez g relatv cme
	brw			; ugrs (pc+1+W) cmre 
nullas	
	movlw	low (egyes-nullas)	; hogy a kvetkez krben a kvetkez
	movwf	m4reg		; ugrcmet vlassza
	banksel	0
	bsf	status,c
	btfsc	porta,3
	bcf	status,c
	rlf	gombok,f
	banksel	latc
	movlw	0x00		; kiolt bjt rtke
	movwf	latc		; kiolts katdban a vlts idejre
	movlw	mask0		; szmjegykijell sz tltse 1. jegyhez
	movwf	latb		; szmjegykijells, gomb strobe 	
	movf	sbuf,w
	movwf	latc		; els szmjegy kdja a b portra
	goto	gomb		; befejezdtt a gombkr
egyes
	movlw	low (kettes-nullas)
	movwf	m4reg		; kvetkez ugrcm elksztse
	banksel	0
	bsf	status,c
	btfsc	porta,3
	bcf	status,c
	rlf	gombok,f
	banksel	latc
	movlw	0x00
	movwf	latc
	movlw	mask1		; 2. jegyhez
	movwf	latb
	movf	sbuf+1,w	
	movwf	latc		; msodik
	goto	raer
kettes
	movlw	low (harmas-nullas)
	movwf	m4reg		; kvetkez ugrcm elksztse
	banksel	0
	bsf	status,c
	btfsc	porta,3
	bcf	status,c
	rlf	gombok,f
	banksel	latc
	movlw	0x00
	movwf	latc
	movlw	mask2		; 2. jegyhez
	movwf	latb
	movf	sbuf+2,w	
	movwf	latc		; msodik
	goto	raer
harmas
	movlw	low (nullas-nullas)
	movwf	m4reg
	banksel	0
	bsf	status,c
	btfsc	porta,3
	bcf	status,c
	rlf	gombok,f
	banksel	latc
	movlw	0x00
	movwf	latc
	movlw	mask3
	movwf	latb
	movf	sbuf+3,w
	movwf	latc
	goto	raer
gomb
	banksel	0
	movlw	15
	andwf	gombok,f	; csak 4 bit maradhat
; ezzel a srgs teendk kttt idztssel letudva, jhet a maradk,
; aminek mr btran lehet fzisonknt eltr hossza.
; gombok 2..0 tartalmazza az aktulis gombllapotot (nyomva=1)	
	djnz	g_cnt,raer
	movlw	t_div3		; ha g_cnt elfogyott:
	movwf	g_cnt
	cjne	gombok,g_old,nog
	movf	gombok,f	; s kett megegyezett, akkor
	btfss	status,z
	bsf	van		; vagy gombok miatt "van"
nog
	movf	gombok,w
	btfsc	status,z
	bsf	nincs		; vagy nincs 1 lesz
atir
	movf	gombok,w	; s az j meg lesz regtve
	movwf	g_old
raer				; nem idkritikus rsz
	banksel	0
	retfie
rev_ph
	movlw	0x80
	addwf	ph_acc,f
	banksel	iocaf
	clrf	iocaf
	retfie	

s7tbl	; a hardverhez igaztva, 0-9, mnusz, P, kt res, H, res
	dt	0x77, 0x44, 0xb5, 0xd5, 0xc6, 0xd3, 0xf3, 0x45
	dt	0xf7, 0xd7, 0x80, 0xa7, 0, 0, 0xe6, 0

start
	banksel	lata
	clrf	lata	
	clrf	m4reg	; gy elszr a nulls gon fut a kijelz
	clrf	latb
	clrf	latc
	banksel	trisa
	movlw	0x3a	;  ra0, ra2 kimenet
	movwf	trisa
	clrf	trisb	; ezeken viszont mind kimenet
	clrf	trisc
	banksel	ansela
	clrf	ansela
	clrf	anselb	; ezeken semmi
	clrf	anselc
	banksel	wpua
	movlw	0x0a	; 
	movwf	wpua
	clrf	wpub
	banksel	iocaf
	bsf	iocap,1
	banksel	osccon
	bcf	option_reg,7
	movlw	0x70	; 8 MHz, de pll on!
	movwf	osccon
	banksel	borcon
	clrf	borcon
	banksel	wdtcon
	movlw	0x16
	movwf	wdtcon
	banksel	dac1con0
	movlw	127
	movwf	dac1con1
	movlw	0x90
	movwf	dac1con0
	banksel	0
	clrf	f1
	clrf	fsr0h
	movlw	10
	movwf	mx_cnt
	movlw	t_div3
	movwf	g_cnt
	clrf	g_old
	movlp	high prefer
	movlw	low prefer +1
	callw
	movwf	index	; 15
;	movl	index,15
	pagesel getdata
	call	getdata
	pagesel	0
	banksel	0
	movlw	249
	movwf	pr2
	clrf	tmr2
	bsf	t2con,tmr2on
	banksel	pie1
	bsf	pie1,tmr2ie
	banksel	ra0pps
	movlw	0eh
	movwf	ra0pps
	banksel	pwm3dch
	movlw	124
	movwf	pwm3dch
	clrf	pwm3dcl
	bsf	pwm3con,7	; PWM INDULHAT
	banksel	iocaf
	bcf	iocaf,1
	banksel	0			
	bsf	intcon,peie
	bsf	intcon,iocie
	bsf	intcon,gie	; csak gombra vagy ra1,2-re van teend!
	bsf	sin_on
buttons
;	goto	buttons				
	jnb	van,buttons	; vr amg van is, nincs is.
	jnb	nincs,buttons
; EGYELRE ITT KELL VRNIA, AMG NEM NYOMOK GOMBOT.		
; itt el kell trteni A start-stop gombot, AMI MG NEM HAT

	snb	stepm	; stepm gomb
	goto	step_m
	snb	le
	call	deci	; ha van le, akkor cskkenti az indexet
	snb	fel
	call	inci	; ha van fel, akkor nveli az indexet
b_common
	banksel	0
	BCF	VAN
	BCF	NINCS
	sb	uj
	goto	buttons
	call	getdata
	call	startf
	goto	buttons
step_m
	movlw	10h
	xorwf	flags,f	; toggle fmod
	call	decseg
	goto	b_common

	
; fmod-tl fggen p_dec-bl vagy f_dec-bl sbuf:4-be	
decseg				
	clrf	fsr0h
	movlw	low p_dec
	snb	fmod
	movlw	low f_dec
	movwf	fsr0l
	banksel	sbuf
	movlp	high s7tbl
	moviw	fsr0++
	andlw	15
	addlw	low s7tbl	; s7tbl alkalmazkodik a bektshez
	callw
	movwf	sbuf
	moviw	fsr0++
	andlw	15
	addlw	low s7tbl
	callw
	movwf	sbuf+1
	moviw	fsr0++
	andlw	15
	addlw	low s7tbl
	callw
	movwf	sbuf+2
	moviw	fsr0++
	andlw	15
	addlw	low s7tbl
	callw
	movwf	sbuf+3
	snb	fmod	; fmod=1-nl frekit r ki
	bsf	sbuf+2,led; az idnek tizedespontja van
	banksel 0
	clrf	pclath
	return
	
stopf
	bcf	sin_on
	banksel	pwm3dch
	movlw	124
	movwf	pwm3dch
	banksel	dac1con0
	movlw	127
	movwf	dac1con1
	banksel	0
	return
startf
	clrf	ph_acc
	clrf	ph_acc+1
	bsf	sin_on
	return

; a fel-le gombok hatsa: (a hibs kezdrtket is behzzk)	
inci	; nvel i_uplim-ig
	call	stopf	; lell
	bsf	uj
	cjael	index, i_uplim,set_iup
	incf	index,f
	return
set_iup
	movlw	i_uplim
	movwf	index
	return

deci	; cskkent 0-ig
	call	stopf	; lell
	bsf	uj
	cjbel	index,0,set_idn
	decf	index,f	
	return
set_idn
	clrf	index
	return
	
getdata			; index alapjn paramterez, mindent tlt
	bcf	status,c
	rlf	index,w
	movwf	cim	; cim=2index
	clrf	fsr1h
	movlw	low fr_reg
	movwf	fsr1l
	movlw	high tbl3
	movwf	fsr0h
	movlw	low tbl3
	addwf	cim,w
	addwf	index,w	; w=bzis + 3index, mert 3 bjtosak az elemek
	movwf	fsr0l
	movlw	3
	movwf	cnt
	call	RD_N_IND
	bcf	status,c
	rlf	cim,f
	movlw	low p_dec
	movwf	fsr1l
	movlw	high tbl1
	movwf	fsr0h
	movlw	low tbl1
	addwf	cim,w	; w=bzis+ 4 index, mert 4 bjtosak az elemek
	movwf	fsr0l
	movlw	4
	movwf	cnt
	call	RD_N_IND
	movlw	low f_dec
	movwf	fsr1l
	movlw	high tbl2
	movwf	fsr0h
	movlw	low tbl2
	addwf	cim,w	; bzis vltozik, cim marad
	movwf	fsr0l
	movlw	4
	movwf	cnt
	call	RD_N_IND
	banksel	0
	call	decseg	; gyrt belle szegmenskpet
	banksel	0
	return
	
	#include <flash.inc>
	
	org	300h
	#include <tbl1.inc>
	org	400h
	#include <tbl2.inc>
	org	500h
	#include <tbl3.inc> 
	org	600h
	#include sin256.inc
	org	800h
	#include <s1024a80.inc>
	
	org	0f80h
prefer	dt	15,15
	end	