; driver33.inc: AD9833 specifikus I/O

; fblk talaktja kivitelre alkalmas formtumra (az als sz kt fels
; bitjt tadja a fels sznak, elhelyezi a cmbiteket). fblk-ban 
; eredetileg a frekvenciasz 28 bitje van, legnagyobb helyrtk a
; legkisebb cmen. Az eredmny fblk-ban kpzdik!!! A cmbitek az
; fselb bjt 3.bitje szerint cmzik valamelyik frekvencia regisztert.
; (ha nulla, akkor az elst, ha 1, akkor a msodikat). A bjtok mg
; nincsenek adsi sorrendben!
ddsprep
	banksel	0
	rlf	fblk+2,f
	rlf	fblk+1,f
	rlf	fblk,f
	rlf	fblk+2,f
	rlf	fblk+1,f
	rlf	fblk,f
	rrf	fblk+2,f
	rrf	fblk+2,f
	movlw	3fh
	andwf	fblk,f
	andwf	fblk+2,f
	movlw	40h	; fr0
	snb	fselb,3
	movlw	80h	; fr1
	iorwf	fblk,f
	iorwf	fblk+2,f
	return
	
; j frekvenciasz kivitele az ppen passzivlt frekvenciaregiszterbe. 4
; bjt megy ki, s a leggyorsabb spi rajel kell neki, klnben kiakadna.
; A 4 bjtos fblk blokkban kapja az elksztett adatot (MSB first),amit
; a megfelel (mdostott) sorrendben kld ki. eltte ddsprep hvand.
ddsout
	clrf	fsr0h
	movlw	fblk+2
	movwf	fsr0l
	banksel	lata
        bcf     seldd
        moviw   fsr0++
	banksel	sspbuf
        movwf   sspbuf
        call	dly4
        call	dly4
        goto	$+1
        moviw   fsr0++
        movwf   sspbuf
        call	dly4
        call	dly4
        movlw	fblk
        movwf	fsr0l
        banksel	lata
        bsf	seldd
        nop
        bcf	seldd
        moviw	fsr0++
        banksel	sspbuf
        movwf   sspbuf
        call	dly4
        call	dly4
        goto	$+1
        moviw	fsr0++
        movwf   sspbuf
        call	dly4
        call	dly4
        goto	$+1
        banksel	lata
        bsf     seldd
	banksel	porta
dly4
        return

; Bjtszint spi tvitel w-bl a kijellt perifrira. A perifrit
; a rutinon kvl kell kijellni az tvitel idejre. Ezt a rutint 
; lehet hasznlni pl. a DDS ic incializlsra s lelltsra 
; (egy kijellsen bell ktszer).
bout
	banksel	sspbuf
	movwf   sspbuf
        nop
        nop
        nop
        nop
        nop
        nop
	nop
        banksel	lata
        return

dum
	nop
	nop
	nop
	nop
	return
; a dds komplett inicializlsa indts nlkl
fullini
        call    spiini          ; spi incializls
        goto    ddsini          ; dds incializls, alv sszeadval
        
confd
	return       

; az spi perifria incializlsa: max. sebessg, idle=0, olvass mindegy
; most mr magas szinten pihen s vltozatlanul a lefutnl rvnyes.
spiini
	banksel	sspcon1
	clrf    sspcon1
        bsf     sspstat,7
        bsf     sspstat,6	; cke=1
        bsf	sspcon3,boen
        bsf	sspcon1,ckp	; ckp=1
        bsf     sspcon1,sspen
        banksel	porta
        return

; a ddsout- hoz szksges regiszterek incializlsa: els rs f0-ba
ddsini
        movl    fselb,28h      ; select f1 s fstopd miatt reset+sleeep1
        goto	fstopd
        return
 
; az elejn letiltja a megszaktst, a vgn akkor engedlyezi, ha a
; tiltskor engedlyezve volt. megszaktson kvli hasznlatra.
stopd				; nem reset, csak sleep1
	bcf	gie_st
	snb	intcon,gie
	bsf	gie_st
	bcf     intcon,gie
	banksel	lata
        bcf     seldd
        banksel	porta
        movf	fselb,w
        call    bout
        movlw	80h	; csak sleep1
        call    bout
        bsf     seldd
        banksel	porta
        snb	gie_st
        bsf     intcon,gie
        return

fstopd			; mg nincs megszakts. reset s sleep1
	banksel	lata
        bcf     seldd
        banksel	porta
        movf	fselb,w
        addlw	1       ; reset, fselb nem jegyzi meg
        call    bout
        movlw	80h	; sleep1
        call    bout
        bsf     seldd
        banksel	porta
        return		; s a vgn nem engedlyezi
        
ph0_0			; nulls fzisregiszter 0 fzisra
	banksel	lata
        bcf     seldd
        banksel	porta
        movlw	0c0h
        call    bout
        movlw	0	
        call    bout
        bsf     seldd
        banksel	porta
        return		
ph1_pi			; egyes fzisregiszter 180 fokra
	banksel	lata
        bcf     seldd
        banksel	porta
        movlw	0e8h
        call    bout
        movlw	0	
        call    bout
        bsf     seldd
        banksel	porta
        return
chg_ph			; fzisregiszter csere
	banksel	lata
	bcf	seldd
	banksel	0
	movlw	4	; fselb.2 az invertland bit
	xorwf	fselb,w
	movwf	fselb
	call	bout
	movlw	0
	call	bout
	bsf	seldd
	banksel	porta
	return	

; az utols regiszterbelltssal elindtja a DDS-t, illene regisztert 
; vltania a kvetkez tlts eltt
startd			
;	bcf	intcon,gie
	banksel	lata
	bcf     seldd
	banksel	0
        movf	fselb,w         ; sleep s reset eltvoltva, mehet
        call    bout
        movlw	0
        call    bout
        bsf     seldd
        banksel	porta
        movlw	8		; fselb.3 az invertland bit
        xorwf	fselb,f		; ha illene, ht teszi.
;        bsf	intcon,gie
        return
      
; kivitt frekvencia aktivlja (aktivls utn vlasztbitet vlt a 
; kvetkez kivitelhez). Ugyanaz, mint a startd, de a megszakts 
; belsejben fut.
ddsact  
	banksel	lata
	bcf     seldd
	banksel	fselb
	movf	fselb,w
	banksel	sspbuf
        movwf   sspbuf
        call	szun4
        call	szun4
        call	szun4
        nop
        nop
        clrw		; a sleepet is leveszi, ha volt
        movwf   sspbuf
        banksel	porta
        movlw	8
        xorwf	fselb,f
        call	szun4
        call	szun4
        call	szun4
        banksel	lata
        bsf     seldd
        banksel	porta
szun4
        return

			
