; metronom.asm: metronm R.J. specifikcija szerint. A flash kezelse 
; hozzcsapva: rdflash(wpts=pitchh), clrflash(void), wrflash(wptr=pitchh)
; wrflash eltt clrflash ktelez. A flash cm rtke default (1F80), de 
; technikai okbl 1f81 lett belle. ra: 4 MHz kvarc.

	list p = 16F1509
	list r = dec
	#include <p16f1509.inc>
	#include <prlx.inc>
	
	__config _CONFIG1, _FOSC_HS & _WDTE_OFF &_PWRTE_OFF &_MCLRE_OFF & _CP_OFF &_BOREN_OFF & _CLKOUTEN_OFF &_IESO_OFF &_FCMEN_OFF
	__CONFIG _CONFIG2, _WRT_OFF & _STVREN_OFF & _BORV_LO & _LPBOR_OFF & _LVP_OFF
	
led	equ	3	; ez a tizedespont bitcme	
mask0	equ	40h	; fels digit
mask1	equ	20h	; kzps digit
mask2	equ	10h	; als digit (vagy fordtva)
p_base	equ	80	; tem alaprtk (programozs utn)
p_uplim	equ	240	; tem maximum
p_dnlim	equ	20	; tem minimum
t_div1	equ	182	; 5 s oszt bels
t_div2	equ	30	; 5 s oszt kls
t_div3	equ	20	; gomb oszt, lervidtve

	cblock	20h
	g_cnt		; gomb szmll
	g_old		; gomb elz
	sd_cnt		; indulsi ksleltets
	endc
	
	cblock	70h
	dec:3		; kirand szm decimlisan
	flags		; jelzbitek, ksbb rszletezve
	aux		; ltalnos segdregiszter
	pitchh		; tem fels a szoft NCO-hoz
	pitchl		; tem als a szoft NCO-hoz
	pitch		; tem valdi binris
	ncach		; szoft fzisakkumultor fels
	ncacl		; szoft fzisakkumultor als
	gombok		; neglt gombkp
	phase		; a hangads fzisa
	adh1		; A/D fels
	adl1		; A/D als
	savtmr1		; ments idzt als
	savtmr2		; ments idzt fels
	endc
	
	#define keyin	porta,3	; gomb mux bemenet
	#define van	flags,0	; van gombnyoms
	#define	nincs	flags,1	; volt sznet
	#define	sav	flags,2	; mentst kell szmolni
	#define do_sav	flags,3	; menteni kell
	#define	nn	flags,4
	#define	sd_dly	flags,5
	#define le	g_old,0	; dekrementlni kell
	#define	r_pbase	g_old,1	; gyri rtket kell visszalltani
	#define	fel	g_old,2	; inkrementlni kell

	
	cblock	0x120	; mert lata, latb, latc oldala
	sbuf:3		; a 3 7 szegmenses szmjegy
	m3reg		; mux regiszter
	endc
	
	org	0
	clrf	pclath
	clrf	intcon
	goto	start
	
	org	4
	banksel	0
	bcf	pir1,tmr2if	; a megszakts flag trlse
; szoft NCO sszeads, hogy szinte precz idzts legyen
	movf	pitchl,w
	addwf	ncacl,f
	movf	pitchh,w
	addwfc	ncach,f
	btfss	status,c
	goto	d_pad
; ha tlcsordult:
	incf	phase,f	
; ugrs phase utols 2 bitje szerinti srgs bitlltsokra
	movf	phase,w
	andlw	7
	brw
	goto	ph0
	goto	ph1
	goto	ph2
	goto	ph2
	goto	ph4
	goto	ph5
	goto	ph2
	goto	ph2
d_pad			; idkiegyenlts, ha nincs feladat
	goto	$+1
	goto	$+1
	goto	$+1
	goto	$+1
	goto	$+1
	nop
	goto	d_mux
ph0
	banksel	lata
	bcf	lata,2
	bsf	sbuf,led	; bal tizedespont be
	banksel	clc1con
	bsf	clc1con,6	; clc1 kimenet engedlyezse
	goto	d_mux
ph1
	banksel	lata
	bcf	lata,2
	bcf	sbuf,led	; bal tizedespont ki
	banksel	clc1con
	bcf	clc1con,6	; clc1 kimenet tiltsa
	goto	d_mux
ph2	nop			; semmittevs
	nop
	nop
	nop
	nop
	goto	d_mux
ph4
	banksel	clc3con
	bsf	clc3pol,1	; clc3 tereszt
	banksel	lata
	bsf	sbuf+2,led	; jobb tizedespont be 
	nop
	goto	d_mux
ph5
	banksel	clc3con
	bcf	clc3pol,1	; clc3 nem ereszt t
	banksel	lata
	bcf	sbuf+2,led	; jobb tizedespont ki
	nop
	nop
	nop
; egyenl hosszal jttek ide, mert a mux is precz idztst kvn:	
d_mux	
	banksel	latc
	movf	m3reg,w		; soron kvetkez g relatv cme
	brw			; ugrs (pc+1+W) cmre 
nullas	
	movlw	low (egyes-nullas)	; hogy a kvetkez krben a kvetkez
	movwf	m3reg		; ugrcmet vlassza
	movlw	0x00		; kiolt bjt rtke
	movwf	latc		; kiolts katdban a vlts idejre
	movlw	mask0		; szmjegykijell sz tltse 1. jegyhez
	movwf	latb		; szmjegykijells, gomb strobe 	
	movf	sbuf,w
	movwf	latc		; els szmjegy kdja a b portra
	banksel	0
	nop
	nop
	btfss	porta,3		; 5 temet kapott bellsra
	bsf	status,c
	btfsc	porta,3
	bcf	status,c
	rlf	gombok,f
	goto	raer
egyes
	movlw	low (kettes-nullas)
	movwf	m3reg		; kvetkez ugrcm elksztse
	movlw	0x00
	movwf	latc
	movlw	mask1		; 2. jegyhez
	movwf	latb
	movf	sbuf+1,w	
	movwf	latc		; msodik
	banksel	0
	nop
	nop
	btfss	porta,3
	bsf	status,c
	btfsc	porta,3
	bcf	status,c
	rlf	gombok,f
	goto	raer
kettes
	movlw	low (nullas-nullas)
	movwf	m3reg
	movlw	0x00
	movwf	latc
	movlw	mask2
	movwf	latb
	movf	sbuf+2,w
	movwf	latc
	banksel	0
	nop
	nop
	btfss	porta,3
	bsf	status,c
	btfsc	porta,3
	bcf	status,c
	rlf	gombok,f	; 3 krnknt 3 gomb beolvasva
; ezzel a srgs teendk kttt idztssel letudva, jhet a maradk,
; aminek mr btran lehet fzisonknt eltr hossza.
; gombok 2..0 tartalmazza az aktulis gombllapotot (nyomva=1)	
	movlw	7
	andwf	gombok,f	; csak 3 bit maradhat
	djnz	g_cnt,raer
	movlw	t_div3		; ha g_cnt elfogyott:
	movwf	g_cnt
	cjne	gombok,g_old,atir
	movf	gombok,f	; s kett megegyezett, akkor
	btfss	status,z
	bsf	van		; vagy van
	movf	gombok,f
	btfsc	status,z
	bsf	nincs		; vagy nincs 1 lesz
atir
	movf	gombok,w	; s az j meg lesz regtve
	movwf	g_old
raer
	banksel	0
	jb	sd_dly,raer0
	decfsz	sd_cnt,raer0
	clrf	pir2
	bsf	sd_dly
raer0
	sb	sav
	goto	raer1
	djnz	savtmr1,raer1
	movlw	t_div1	
	movwf	savtmr1
	djnz	savtmr2,raer1
	bcf	sav
	bsf	do_sav
raer1
	rrf	phase,w	
	andlw	3
	brw
	goto	csere2
	goto	olvas2
	goto	csere1
	banksel	adcon0
	bsf	adcon0,go
adlp1
	jb	adcon0,go,adlp1
	clrf	adh1
	movf	adresh,w
	addlw	0x4c
	movwf	adl1
	snc
	incf	adh1,f
	banksel	nco1con
	movf	adh1,w
	movwf	nco1inch
	movf	adl1,w
	movwf	nco1incl
	retfie
csere1
	banksel	adcon0
	movlw	5	
	movwf	adcon0	; ad channel 1
	retfie
olvas2
	banksel	adcon0
	bsf	adcon0,go
adlp2
	jb	adcon0,go,adlp2
	clrf	adh1
	movf	adresh,w
	addlw	0x4c
	movwf	adl1
	snc
	incf	adh1,f
	banksel	nco1con
	movf	adh1,w
	movwf	nco1inch
	movf	adl1,w
	movwf	nco1incl
	retfie
csere2
	banksel	adcon0
	movlw	0x01
	movwf	adcon0	; ad channel 0
	retfie

s7tbl	; a hardverhez igaztva, 0-9, nincs spec. karakter
	dt	0x77, 0x44, 0xb5, 0xd5, 0xc6, 0xd3, 0xf3, 0x45
	dt	0xf7, 0xd7, 0, 0, 0, 0, 0, 0 

start
	banksel	lata
	clrf	lata	; csak ra2 miatt, aki clc kimenet lesz.
	clrf	m3reg	; gy elszr a nulls gon fut a kijelz
	clrf	latb
	clrf	latc
	banksel	trisa
	movlw	0x3b	; csak ra2 kimenet
	movwf	trisa
	clrf	trisb	; ezeken viszont mind kimenet
	clrf	trisc
	banksel	ansela
	movlw	0x03	; ra1,0 analg 
	movwf	ansela
	clrf	anselb	; ezeken semmi
	clrf	anselc
	banksel	wpua
	movlw	0x08	; ra3 kap felhzt
	movwf	wpua
	clrf	wpub
	banksel	osccon
	bcf	option_reg,7
	movlw	0x68	; 4 MHz
	movwf	osccon
	banksel	borcon
	clrf	borcon
	banksel	wdtcon
	movlw	0x16
	movwf	wdtcon
	#include <janimetr.inc>	; a kt CLC alapllapota
	banksel	adcon0
	movlw	5
	movwf	adcon0	; els hang potija
	movlw	0x40	; balra tmrt, fosc/4
	movwf	adcon1
	clrf	adcon2
	clrf	adresl
	clrf	adresh
	banksel	nco1con
	clrf	nco1con
	movlw	1
	movwf	nco1clk	; 4 MHz
	clrf	nco1accu
	clrf	nco1acch
	clrf	nco1accl
	clrf	nco1inch
	; ide jn az els poti ,1 egysg kb. 1,9 Hz
	call	rdpot1	; ebbl lesz a hangfreki
	bsf	nco1con,n1en	; mkdhet az nco, de nincs kimenete
	call	rdflash	; innen jn az tem
	call	px4	; 1 bjt van elrakva, szorozni kell nggyel
	call	bindecp	; a kijelznek az eredeti kell, decimlisan
	call	decseg	; pontosabban annak a szegmenskpe
	banksel	0
	clrf	flags
	clrf	sd_cnt
	clrf	tmr2
	movlw	0xe4
	movwf	pr2	; 1092,6667 Hz-et kellene csinlni a pontoshoz
	movlw	5
	movwf	t2con	; a kett egytt 916-tal oszt (1091,703 Hz lesz)
	banksel	pie1
	bsf	pie1,tmr2ie
	banksel	0
	movlw	t_div3
	movwf	g_cnt
	clrf	g_old
	bsf	intcon,peie
	bsf	intcon,gie
loop
	jnb	do_sav,buttons	; kezdetben biztosan trlve
	call	clrflash
	call	wrflash
	bcf	do_sav
buttons
	banksel	0
	jnb	van,loop	; ha hinyzik a van, csak idztene
	jnb	nincs,loop	; a nincs
	movf	g_old,f
	snz
	goto	loop	; meg ha most ppen nincs, akkor is
	movlw	t_div1	; van, nincs, most ppen van, gy
	movwf	savtmr1	; savtmr1=t_div1
	movlw	t_div2
	movwf	savtmr2	; savtmr2=t_div2
	bsf	sav	; sav=1
; eddig csak idztt indtott, most jnnnek a gombok:
	movlw	p_base
	snb	r_pbase
	movwf	pitch	; ha a kzps 1, akkor 80-at r, utna pedig
	snb	le
	call	decp	; ha van le, akkor cskkenti (akr a 80-at is)
	snb	fel
	call	incp	; ha van fel, akkor nveli (akr az elzt is)
	call	px4
	call	bindecp
	call	decseg	; gyrt belle szegmenskpet
	banksel	0
	bcf	van	; trli mindkt flaget
	bcf	nincs
	goto	loop	; s vr j esemnyre, ami gomb vagy ments
; ha teht van is, nincs is s most ppen van, akkor mindenkpp lp,
; vagy 80-at r. Vge a fprogramnak.

rdpot1			; szub: 1. poti beolvassa
	banksel	adcon0
	movlw	1
	movwf	adcon0
	nop
	nop
	nop
	nop
	bsf	adcon0,go
adlp3
	jb	adcon0,go,adlp3
	clrf	adh1
	movf	adresh,w
	addlw	0x4c
	movwf	adl1
	snc
	incf	adh1,f		; talaktsa NCO nvekmnny
	banksel	nco1con
	movf	adh1,w
	movwf	nco1inch
	movf	adl1,w
	movwf	nco1incl	; s leraksa NCO nvekmnyknt
	return
	
	#include <flash.inc>	; minimalizlt flash kezels	
	
px4				; sszeadandt gyrt a szoft NCO-nak
	BCF	INTCON,GIE
	clrf	pitchh
	clc
	rlf	pitch,w
	movwf	pitchl
	rlf	pitchh,f
	clc	
	rlf	pitchl,f
	rlf	pitchh,f
	BSF	INTCON,GIE
	return

bindecp				; BINRIS TEMBL DECIMLIS
	movf	pitch,w
	movwf	aux		
	movl	dec,-1
	movlw	100
bdl
	incf	dec,f
	subwf	aux,f
	snc
	goto	bdl
	addwf	aux,f
	movl	dec+1,-1
	movlw	10
bdl1
	incf	dec+1,f
	subwf	aux,f
	snc
	goto	bdl1
	addwf	aux,w
	movwf	dec+2
	return
	
decseg				; DEC...DEC+2-BL SBUF...SBUF+2
	banksel	sbuf
	movf	dec,w
	addlw	low s7tbl	; s7tbl mr alkalmazkodik a bektshez
	callw
	movwf	sbuf
	movf	dec+1,w
	addlw	low s7tbl
	callw
	movwf	sbuf+1
	movf	dec+2,w
	addlw	low s7tbl
	callw
	movwf	sbuf+2
	return
	
incp				; GYORST p_uplim-ig
	cjael	pitch,p_uplim,s_uplim
	incf	pitch,f	
	return
s_uplim
	movlw	p_uplim
	movwf	pitch
	return

decp				; LASST p_dnlim-ig
	cjbel	pitch,p_dnlim,s_dnlim
	decf	pitch,f	
	return
s_dnlim
	movlw	p_dnlim
	movwf	pitch
	return
	
	org	1f80h
	dt	p_base,p_base,p_base,p_base	; default rtk
	end	